/****************************************************************************
 *
 * Julia set test program for PS3 cell architecture.
 *
 * (c) 2007 Ranulf Doswell <dev@ranulf.net>
 *
 * I've only been programming the PS3 for just over 24 hours and here is my
 * first attempt at just the SPUs, DMA transfers and hand-optimising SBU
 * assembler (such a nice processor to experiment with)...
 *
 * Please feel free to use this as a basis for your experimentations, but if
 * you come up with anything cool, please let me know!
 *
 ****************************************************************************/

/*
 * I wanted to use libspe2, but DMA seems to be completely broken.
 * Consequently, I'll wrap everything up in this spu class so that
 * it can all be refactored fairly easily
 */

#include <stdio.h>
#include <libspe.h>

class Spu {
public:
	Spu(spe_program_handle_t* program, void* argv, void* env);
	~Spu();
	
	int join();			// block until SPU process completed
	speid_t getID();

	void write(int msg);	// mailbox write
	int read();				// mailbox read

private:
	speid_t spe_id;
};
